﻿Type=Class
Version=2.02
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private x, y As Float
	Private size As Float
	Private vx, vy As Float
	Private color As Int
	Private logSize As Float
	Private myMoons As List
End Sub

Public Sub Initialize (vSize As Float, vColor As Int, startX As Float, startY As Float _
	,startVX As Float, startVY As Float)
	size = vSize
	color = vColor
	vx = startVX
	vy = startVY
	x = startX
	y = startY
	logSize = Logarithm(size, 3)
	myMoons.Initialize
End Sub

Public Sub CreateMoon (vColor As Int, dist As Float, v As Float) As Star
	Dim m As Star
	m.Initialize(size / 100, vColor, x , y  - dist, v,0)
	myMoons.Add(m)
	Return m
End Sub

Public Sub Erase(C As Canvas, zoom As Float)
	C.DrawCircle(x * zoom, y * zoom, logSize * zoom, Colors.Black, True, 0)
End Sub

Public Sub Draw(C As Canvas, zoom As Float)
	C.DrawCircle(x * zoom, y * zoom, logSize * zoom , color, True,  0)
End Sub

Public Sub CalculateForce(Time As Float)
	For i = 0 To myMoons.Size - 1
		Dim other As Star
		other = myMoons.Get(i)
		'Notice that we can access private fields of other stars in the Star class code
		Dim a, r2, angle As Float
		'distance
		r2 = Max(1, Power(other.x - x, 2) + Power(other.y - y, 2))
		'acceleration
		a = Min(0.001, size / r2 *  Main.GForce / 50000)
		angle = ATan2(y - other.y, x - other.x)
		'calculate new velocity
		other.vx = other.vx + a * Cos(angle) * Time
		other.vy = other.vy + a * Sin(angle) * Time
		Dim dx, dy As Float
		dx = other.vx * Time
		dy = other.vy * Time
		'calculate new position
		other.x = other.x + dx
		other.y = other.y + dy
		'Update the other star moons position (the moons movement is related to their "sun" position)
		For i2 = 0 To other.myMoons.Size - 1
			Dim m As Star
			m = other.myMoons.Get(i2)
			m.x = m.x + dx
			m.y = m.y + dy
		Next
	Next
End Sub